switch over to libpicofe
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 echo "" > $TMPC
28 $CC -E -dD $CFLAGS $TMPC | grep -q $1 || return 1
29 return 0
30}
31
32# setting options to "yes" or "no" will make that choice default,
33# "" means "autodetect".
34
35platform_list="generic pandora maemo caanoo libretro"
36platform="generic"
37builtin_gpu_list="peops unai neon"
38builtin_gpu=""
39sound_driver_list="oss alsa sdl pulseaudio libretro"
40sound_drivers=""
41plugins="plugins/spunull/spunull.so \
42plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
43ram_fixed="no"
44drc_cache_base="no"
45have_armv6=""
46have_armv7=""
47have_arm_neon=""
48have_tslib=""
49enable_dynarec="yes"
50need_sdl="no"
51need_libpicofe="yes"
52need_warm="no"
53# these are for known platforms
54optimize_cortexa8="no"
55optimize_arm926ej="no"
56
57# hardcoded stuff
58CC="${CC-${CROSS_COMPILE}gcc}"
59CXX="${CXX-${CROSS_COMPILE}g++}"
60AS="${AS-${CROSS_COMPILE}as}"
61AR="${AS-${CROSS_COMPILE}ar}"
62MAIN_LDLIBS="$LDLIBS -ldl -lm"
63config_mak="config.mak"
64
65fail()
66{
67 echo "$@"
68 exit 1
69}
70
71# call during arg parsing, so that cmd line can override platform defaults
72set_platform()
73{
74 platform=$1
75 case "$platform" in
76 generic)
77 ;;
78 pandora)
79 sound_drivers="oss alsa"
80 ram_fixed="yes"
81 drc_cache_base="yes"
82 optimize_cortexa8="yes"
83 have_arm_neon="yes"
84 ;;
85 maemo)
86 ram_fixed="yes"
87 drc_cache_base="yes"
88 optimize_cortexa8="yes"
89 have_arm_neon="yes"
90 ;;
91 caanoo)
92 sound_drivers="oss"
93 ram_fixed="yes"
94 drc_cache_base="yes"
95 optimize_arm926ej="yes"
96 need_warm="yes"
97 ;;
98 libretro)
99 sound_drivers="libretro"
100 need_libpicofe="no"
101 ;;
102 *)
103 fail "unsupported platform: $platform"
104 ;;
105 esac
106}
107
108for opt do
109 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
110 case "$opt" in
111 --help|-h) show_help="yes"
112 ;;
113 --platform=*) set_platform "$optarg"
114 ;;
115 --gpu=*) builtin_gpu="$optarg"
116 ;;
117 --sound-drivers=*) sound_drivers="$optarg"
118 ;;
119 --enable-neon) have_arm_neon="yes"
120 ;;
121 --disable-neon) have_arm_neon="no"
122 ;;
123 --disable-dynarec) enable_dynarec="no"
124 ;;
125 *) echo "ERROR: unknown option $opt"; show_help="yes"
126 ;;
127 esac
128done
129
130if [ "$show_help" = "yes" ]; then
131 echo "options:"
132 echo " --help print this message"
133 echo " --platform=NAME target platform [$platform]"
134 echo " available: $platform_list"
135 echo " --gpu=NAME builtin gpu plugin [guessed]"
136 echo " available: $builtin_gpu_list"
137 echo " --sound-drivers=LIST sound output drivers [guessed]"
138 echo " available: $sound_driver_list"
139 echo " --enable-neon"
140 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
141 echo " --disable-dynarec disable dynamic recompiler"
142 echo " (dynarec is only available and enabled on ARM)"
143 echo "influential environment variables:"
144 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
145 exit 1
146fi
147
148# validate selections
149if [ "x$builtin_gpu" != "x" ]; then
150 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
151 fail "unsupported builtin gpu plugin: $builtin_gpu"
152 fi
153fi
154
155if [ "x$sound_drivers" != "x" ]; then
156 for d in $sound_drivers; do
157 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
158 fail "unsupported sound driver: $sound_driver"
159 fi
160 done
161fi
162
163if [ "$need_libpicofe" = "yes" ]; then
164 if ! test -f "frontend/libpicofe/README"; then
165 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
166 fi
167fi
168
169if [ "$need_warm" = "yes" ]; then
170 if ! test -f "frontend/warm/README"; then
171 fail "wARM is missing, please run 'git submodule init && git submodule update'"
172 fi
173fi
174
175if [ -z "$ARCH" ]; then
176 ARCH=`$CC -v 2>&1 | grep -i 'target:' | awk '{print $2}' \
177 | awk -F '-' '{print $1}'`
178fi
179
180# ARM stuff
181if [ "$ARCH" = "arm" ]; then
182 if [ "$optimize_cortexa8" = "yes" ]; then
183 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
184 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
185 fi
186 if [ "$optimize_arm926ej" = "yes" ]; then
187 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
188 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
189 fi
190
191 if [ "x$have_arm_neon" = "x" ]; then
192 # detect NEON from user-supplied cflags to enable asm code
193 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
194 fi
195 if [ "x$have_armv6" = "x" ]; then
196 have_armv6=`check_define __ARM_ARCH_6 && echo yes` || true
197 fi
198 if [ "x$have_armv7" = "x" ]; then
199 if check_define __ARM_ARCH_7A__; then
200 have_armv6="yes"
201 have_armv7="yes"
202 fi
203 fi
204
205 if [ "x$builtin_gpu" = "x" ]; then
206 if [ "$have_arm_neon" = "yes" ]; then
207 builtin_gpu="neon"
208 elif [ "$have_armv7" != "yes" ]; then
209 # pre-ARMv7 hardware is usually not fast enough for peops
210 builtin_gpu="unai"
211 else
212 builtin_gpu="peops"
213 fi
214 fi
215
216 # automatically set mfpu and mfloat-abi if they are not set
217 if [ "$have_arm_neon" = "yes" ]; then
218 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=neon"
219 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=neon"
220 elif [ "$have_armv6" = "yes" ]; then
221 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=vfp"
222 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=vfp"
223 fi
224 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
225 if [ "$floatabi_set_by_gcc" != "yes" -a "$have_armv6" = "yes" ]; then
226 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
227 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
228 fi
229
230 # must disable thumb as recompiler can't handle it
231 if check_define __thumb__; then
232 CFLAGS="$CFLAGS -marm"
233 fi
234
235 if [ "$have_armv7" = "yes" ]; then
236 ASFLAGS="$ASFLAGS --defsym HAVE_ARMV7=1"
237 else
238 ASFLAGS="$ASFLAGS --defsym HAVE_ARMV7=0"
239 fi
240else
241 # dynarec only available on ARM
242 enable_dynarec="no"
243fi
244
245if [ "x$builtin_gpu" = "x" ]; then
246 builtin_gpu="peops"
247fi
248
249#if [ "$ARCH" = "x86_64" ]; then
250 # currently we are full of 32bit assumptions,
251 # at least savestate compatibility will break without these
252# CFLAGS="$CFLAGS -m32"
253# LDFLAGS="$LDFLAGS -m32"
254#fi
255
256# supposedly we can avoid -fPIC on armv5 for slightly better performace?
257if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
258 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
259fi
260
261if [ "$ram_fixed" = "yes" ]; then
262 CFLAGS="$CFLAGS -DRAM_FIXED"
263fi
264
265case "$platform" in
266generic)
267 need_sdl="yes"
268 ;;
269maemo)
270 maemo_cflags=`pkg-config --cflags hildon-1`
271 maemo_ldlibs=`pkg-config --libs hildon-1`
272 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES $maemo_cflags"
273 MAIN_LDLIBS="$MAIN_LDLIBS $maemo_ldlibs"
274 ;;
275libretro)
276 CFLAGS="$CFLAGS -fPIC"
277 LDFLAGS="$LDFLAGS -shared"
278 ;;
279esac
280
281# header/library presence tests
282check_zlib()
283{
284 cat > $TMPC <<EOF
285 #include <zlib.h>
286 int main(void) { uncompress(0, 0, 0, 0); }
287EOF
288 compile_binary
289}
290
291check_bzlib()
292{
293 cat > $TMPC <<EOF
294 #include <bzlib.h>
295 void main() { BZ2_bzBuffToBuffDecompress(0, 0, 0, 0, 0, 0); }
296EOF
297 compile_object
298}
299
300check_libpng()
301{
302 cat > $TMPC <<EOF
303 #include <png.h>
304 void main() { png_init_io(0, 0); }
305EOF
306 compile_binary
307}
308
309check_oss()
310{
311 cat > $TMPC <<EOF
312 #include <sys/soundcard.h>
313 #include <sys/ioctl.h>
314 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
315EOF
316 compile_binary
317}
318
319check_alsa()
320{
321 cat > $TMPC <<EOF
322 #include <alsa/asoundlib.h>
323 void main() { snd_pcm_open(0, 0, 0, 0); }
324EOF
325 compile_binary "$@"
326}
327
328check_sdl()
329{
330 cat > $TMPC <<EOF
331 #include <SDL.h>
332 void main() { SDL_OpenAudio(0, 0); }
333EOF
334 compile_binary "$@"
335}
336
337MAIN_LDLIBS="$MAIN_LDLIBS -lz"
338check_zlib || fail "please install zlib (libz-dev)"
339
340check_bzlib || fail "please install bz2lib (libbz2-dev)"
341
342MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
343check_libpng || fail "please install libpng (libpng-dev)"
344
345# find what audio support we can compile
346if [ "x$sound_drivers" = "x" ]; then
347 if check_oss; then sound_drivers="$sound_drivers oss"; fi
348 if check_alsa -lasound; then
349 sound_drivers="$sound_drivers alsa"
350 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
351 fi
352 if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then
353 sound_drivers="$sound_drivers sdl"
354 need_sdl="yes"
355 fi
356else
357 if echo $sound_drivers | grep -q "\<oss\>"; then
358 check_oss || fail "oss support is missing"
359 fi
360 if echo $sound_drivers | grep -q "\<alsa\>"; then
361 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
362 check_alsa || fail "please install libasound2-dev"
363 fi
364fi
365
366if [ "$need_sdl" = "yes" ]; then
367 which sdl-config > /dev/null || \
368 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
369 CFLAGS="$CFLAGS `sdl-config --cflags`"
370 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
371 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
372fi
373
374# check for tslib (only headers needed)
375if [ "x$have_tslib" = "x" ]; then
376 cat > $TMPC <<EOF
377 #include <tslib.h>
378 void test(struct ts_sample sample) {}
379EOF
380 if compile_object; then
381 have_tslib="yes"
382 else
383 have_tslib="no"
384 fi
385fi
386
387# check for GLES headers
388cat > $TMPC <<EOF
389#include <GLES/gl.h>
390#include <GLES/glext.h>
391#include <EGL/egl.h>
392void *test(void) {
393 return eglGetDisplay( (EGLNativeDisplayType)0 );
394}
395EOF
396if compile_object; then
397 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
398fi
399
400if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
401 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
402fi
403
404cat > $TMPC <<EOF
405void test(void *f, void *d) { fread(d, 1, 1, f); }
406EOF
407if compile_object -Wno-unused-result; then
408 CFLAGS="$CFLAGS -Wno-unused-result"
409fi
410
411# short plugin list for display
412for p in $plugins; do
413 p1=`basename $p`
414 plugins_short="$p1 $plugins_short"
415done
416
417# set things that failed to autodetect to "no"
418test "x$have_armv6" != "x" || have_armv6="no"
419test "x$have_armv7" != "x" || have_armv7="no"
420test "x$have_arm_neon" != "x" || have_arm_neon="no"
421
422echo "architecture $ARCH"
423echo "platform $platform"
424echo "built-in GPU $builtin_gpu"
425echo "sound drivers $sound_drivers"
426echo "plugins $plugins_short"
427echo "C compiler $CC"
428echo "C compiler flags $CFLAGS"
429echo "libraries $MAIN_LDLIBS"
430echo "linker flags $LDFLAGS"
431echo "enable dynarec $enable_dynarec"
432echo "ARMv7 optimizations $have_armv7"
433echo "enable ARM NEON $have_arm_neon"
434echo "tslib support $have_tslib"
435
436echo "# Automatically generated by configure" > $config_mak
437printf "# Configured with:" >> $config_mak
438printf " '%s'" "$0" "$@" >> $config_mak
439echo >> $config_mak
440
441echo "CC = $CC" >> $config_mak
442echo "CXX = $CXX" >> $config_mak
443echo "AS = $AS" >> $config_mak
444echo "CFLAGS += $CFLAGS" >> $config_mak
445echo "ASFLAGS += $ASFLAGS" >> $config_mak
446echo "LDFLAGS += $LDFLAGS" >> $config_mak
447echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
448echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
449echo >> $config_mak
450
451if [ "$platform" = "libretro" ]; then
452 echo "TARGET = libretro.so" >> $config_mak
453fi
454echo "ARCH = $ARCH" >> $config_mak
455echo "PLATFORM = $platform" >> $config_mak
456echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
457echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
458if [ "$ARCH" = "arm" ]; then
459 echo "PLUGINS = $plugins" >> $config_mak
460else
461 echo -n "PLUGINS =" >> $config_mak
462 for p in $plugins; do
463 echo -n " ${p}.${ARCH}" >> $config_mak
464 done
465 echo >> $config_mak
466fi
467if [ "$have_armv6" = "yes" ]; then
468 echo "HAVE_ARMV6 = 1" >> $config_mak
469fi
470if [ "$have_armv7" = "yes" ]; then
471 echo "HAVE_ARMV7 = 1" >> $config_mak
472fi
473if [ "$have_arm_neon" = "yes" ]; then
474 echo "HAVE_NEON = 1" >> $config_mak
475fi
476if [ "$have_tslib" = "yes" ]; then
477 echo "HAVE_TSLIB = 1" >> $config_mak
478fi
479if [ "$enable_dynarec" = "yes" ]; then
480 echo "USE_DYNAREC = 1" >> $config_mak
481fi
482if [ "$drc_cache_base" = "yes" ]; then
483 echo "DRC_CACHE_BASE = 1" >> $config_mak
484fi
485
486# use pandora's skin (for now)
487test -e skin || ln -s frontend/pandora/skin skin
488
489# vim:shiftwidth=2:expandtab